package nl.uvt.locator;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.servlet.http.HttpServletRequest;

public class QueryData {
	String genre;   
	String issn;
	String isbn;
	String title;
	String atitle;
	String epn;
	String database;
	String oIssue;
	String location;
	int year;
	int volume;
	int issue;
	String spage;
	QueryData(){
		genre = "article";
		issn = "";
		isbn = "";
		title = "";
		atitle = "";
		oIssue = "";
		epn = "";
		database = "";
		year = -1;
		volume = -1;
		issue = -1;
		spage = "";
		location = "";
	}

	public String toString(){
		String result = "genre=" + genre;
		result += ", title=" + title;
		result += ", atitle=" + atitle;
		result += ", issn=" + issn;
		result += ", isbn=" + isbn;
		result += ", database="+ database;
		result += ", epn="+ epn;
		result += ", year="+ year;
		result += ", volume=" + volume;
		result += ", issue=" + issue;
		result += ", location=" + location;
		result += ", origIssue=" + oIssue;
		result += ", spage=" + spage;
		return result;
	}

	public boolean parseQuery( HttpServletRequest rec ) {
		Locator.logger.debug( rec.getQueryString());
		String par = rec.getParameter( "genre" );
		if ( par != null && par.length() > 0 )
			genre = par;
		par = rec.getParameter( "issn" );
		if ( par != null && par.length() > 0 ){
			issn = par.trim();
			issn = issn.replaceAll("-", "");
		}
		par = rec.getParameter( "isbn" );
		if ( par != null && par.length() > 0 ){
			isbn = par.trim();
			isbn = isbn.replaceAll("-", "");
		}
		par = rec.getParameter( "location" );
		if ( par != null && par.length() > 0 )
			location = par;
		par = rec.getParameter( "title" );
		if ( par != null && par.length() > 0 )
			title = par;
		par = rec.getParameter( "atitle" );
		if ( par != null && par.length() > 0 )
			atitle = par;
		par = rec.getParameter( "epn" );
		if ( par != null && par.length() > 0 )
			epn = par;
		par = rec.getParameter( "oissue" );
		if ( par != null && par.length() > 0 )
			oIssue = par;
		par = rec.getParameter( "spage" );
		if ( par != null && par.length() > 0 ){
			Pattern braces = Pattern.compile("^\\d+");
			Matcher myMatch = braces.matcher(par);
			String match = "";
			if ( myMatch.find() ){
				match = myMatch.group(0);
				Locator.logger.debug( "final spages match = " + match );
				spage = match;
			}
			else
			spage	 = par;
		}
		try {
			par = rec.getParameter( "year" );
			if ( par != null && par.length() > 0 )
				year = Integer.parseInt( par );
			par = rec.getParameter( "date" );
			if ( par != null && par.length() > 0 )
				year = Integer.parseInt( par );
			par = rec.getParameter( "volume" );
			if ( par != null && par.length() > 0 ){
				// try to compensate for volumes like: '11 Suppl 1'
				String[] parts = par.split(" ");
				if ( parts.length > 0 )
					volume = Integer.parseInt( parts[0] );
				else
					volume = Integer.parseInt( par );
			}
			par = rec.getParameter( "issue" );
			if ( par != null && par.length() > 0 )
				issue = Integer.parseInt( par );
		}
		catch( NumberFormatException e ){
			Locator.logger.debug( "Integer.parse() failed on:" + par );
			return false;
		}
		return true;
	}

}
